/*******************************************************************************
 Comments v1.0 - 24/08/2006
 maleval@gawab.com 
 Mise  jour (28/11/2007) : Ajout des commentaires 
-----------------------------------------------------------------------------
Insrer commentaires HTML, commentaires multi-lignes et ligne simple :
  Insrent des commentaires autour d'une slection.
  S'il n'y pas de slection, les balises de commentaires sont insres
  au point d'insertion. Pour les commentaires simple ligne, un double slash
  est insr au dbut de chaque ligne de la slection (s'il y en a une).

Supprimer balises de commentaires :
  Recherche les balises de commentaires dans la slection.
  S'il n'y a pas de slection, recherche dans la ligne active.
  Les commentaires en eux-mmes ne sont pas supprims.

Supprimer tous les commentaires :
  Grand nettoyage. Tous les commentaires (et donc leurs contenus) sont
  supprims, sauf les commentaires HTML.
   utiliser avec prudence, selon ce que vous avez dans le document !
  Je conseille vivement un backup avant.

Test avec PSPad 4.5.1 (2207) - Win XP SP2
*******************************************************************************/

var module_name = "InsertComments_fr";
var module_ver = "1.0";

function insertHTMLComments(){
  var ceDoc = newEditor();
  ceDoc.assignActiveEditor();
  var s = ceDoc.selText();
  s = "<!--"+s+"-->";
  ceDoc.selText(s);
}

function insertMultiLinesComments(){
  var ceDoc = newEditor();
  ceDoc.assignActiveEditor();
  var s = ceDoc.selText();
  s = "/*"+s+"*/";
  ceDoc.selText(s);
}

function insertSingleLineComments(){
  var ceDoc = newEditor();
  ceDoc.assignActiveEditor();
  var l, i, s;
  s = ceDoc.selText();
  var sArr = s.split("\n");
  for (i in sArr) {
    l = "//"+sArr[i];
    ceDoc.selText(l);
  }
}

function insertBashComments(){
  var ceDoc = newEditor();
  ceDoc.assignActiveEditor();
  var l, i, s;
  s = ceDoc.selText();
  var sArr = s.split("\n");
  for (i in sArr) {
    l = "#"+sArr[i];
    ceDoc.selText(l);
  }
}

function removeCommentsTags(){
  var r, s, flag = false;;
  var ceDoc = newEditor();
  ceDoc.assignActiveEditor();
  s = ceDoc.selText();

  if (!s) {
    flag = true;
    s = ceDoc.lineText();
  }

  r = /<!--|-->|#|\/\*|\*\/|\/\//g;
  var res = s.search(r);

  if (res != -1) {
    s = s.replace(r, "");
    if (!flag) {
      ceDoc.selText(s);
    }
    else {
      ceDoc.lineText(s);
    }
  }
}

function removeAllComments(){
  var warning = "Cette option supprime TOUS les commentaires du document.\n "+
                "Confirmer ?";

  if (confirm(warning)) {
    var r, s, x, y;
    var ceDoc = newEditor();
    ceDoc.assignActiveEditor();

    x = ceDoc.caretX();
    y = ceDoc.caretY();
    s = ceDoc.text();

    // Nettoyer commentaires ligne simple
    // Convertir avant les URL en http:/
    r = new RegExp("([a-z]+)://", "g");
    s = s.replace(r, "$1:/");

    // Commentaires ligne simple
    r = /\/\/.*/g;
    s = s.replace(r,"");

    // Conversion inverse pour les URL
    r = new RegExp("([a-z]+):/", "g");
    s = s.replace(r, "$1://");

    // Commentaires multilignes
    r = /\/\*[^\*\/]*\*\//g;
    s = s.replace(r,"");

    ceDoc.text(s);
    ceDoc.setCaretPos(x,y);
  }
}

function Init(){
  addMenuItem("Insrer commentaires HTML <!-- --> ", "Commentaires", "insertHTMLComments");
  addMenuItem("Insrer commentaires multi-lignes /* */", "Commentaires", "insertMultiLinesComments");
  addMenuItem("Insrer commentaires ligne simple //", "Commentaires", "insertSingleLineComments");
  addMenuItem("Insrer commentaires ligne simple #", "Commentaires", "insertBashComments");
  addMenuItem("-", "Commentaires", "");
  addMenuItem("Supprimer balises de commentaires", "Commentaires", "removeCommentsTags");
  addMenuItem("Supprimer tous les commentaires", "Commentaires", "removeAllComments");
}

function confirm(text) {
  // Provided by gogogadgetscott
  // http://forum.pspad.com/read.php?2,30707
  text = text ? text : "Are you sure ?"; 
  var ie = CreateObject("InternetExplorer.Application");
  ie.width = 0; ie.height = 0; ie.left = 10000000; ie.visible = true;

  ie.navigate("about:blank");

  var returnValue = ie.Document.parentWindow.confirm(text);
  ie.quit();
  return returnValue;
}
